www/project/src/Entity/Product.php
<?php

namespace App\Entity;

use App\Repository\ProductRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity(repositoryClass=ProductRepository::class)
 * @UniqueEntity(
 *     fields={"name"},
 *     message="Ce nom n'est pas disponible."
 * )
 */
class Product
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(
     *     message = "Le nom du produit est obligatoire."
     * )
     */
    private $name;

    /**
     * @ORM\ManyToOne(targetEntity=Category::class, inversedBy="products")
     * @ORM\JoinColumn(nullable=false)
     * @Assert\NotBlank(
     *     message = "Le produit doit être lié à une catégorie."
     * )
     */
    private $category;

    /**
     * @ORM\OneToMany(targetEntity=Picture::class, mappedBy="product", orphanRemoval=true)
     */
    private $pictures;

    /**
     * @ORM\OneToMany(targetEntity=Review::class, mappedBy="product", orphanRemoval=true)
     */
    private $reviews;

    public function __construct()
    {
        $this->pictures = new ArrayCollection();
        $this->reviews = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getCategory(): ?Category
    {
        return $this->category;
    }

    public function setCategory(?Category $category): self
    {
        $this->category = $category;

        return $this;
    }

    /**
     * @return Collection|Picture[]
     */
    public function getPictures(): Collection
    {
        return $this->pictures;
    }

    public function addPicture(Picture $picture): self
    {
        if (!$this->pictures->contains($picture)) {
            $this->pictures[] = $picture;
            $picture->setProduct($this);
        }

        return $this;
    }

    public function removePicture(Picture $picture): self
    {
        if ($this->pictures->removeElement($picture)) {
            // set the owning side to null (unless already changed)
            if ($picture->getProduct() === $this) {
                $picture->setProduct(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Review[]
     */
    public function getReviews(): Collection
    {
        return $this->reviews;
    }

    public function addReview(Review $review): self
    {
        if (!$this->reviews->contains($review)) {
            $this->reviews[] = $review;
            $review->setProduct($this);
        }

        return $this;
    }

    public function removeReview(Review $review): self
    {
        if ($this->reviews->removeElement($review)) {
            // set the owning side to null (unless already changed)
            if ($review->getProduct() === $this) {
                $review->setProduct(null);
            }
        }

        return $this;
    }

    public function getThumbnail(): ?Picture
    {
        return $this->getPictures()->filter(function(Picture $picture): bool {
            return $picture->getIsThumbnail();
        })->get(0);
    }

    public function getAverageNote(): float
    {
        $notes = $this->getReviews()->map(function(Review $review): float {
            return $review->getNote();
        })->toArray();

        return $notes ? round(array_sum($notes)/sizeof($notes)*2, 0, PHP_ROUND_HALF_UP)/2 : 0;
    }
}

www/project/src/Controller/HomeController.php
<?php

namespace App\Controller;

use App\Entity\Category;
use App\Entity\Product;
use App\Form\CategorySelectorType;
use App\Form\ChoiceCategoryType;
use Doctrine\ORM\EntityRepository;
use Exception;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Validator\Constraints\Choice;

class HomeController extends AbstractController
{
    /**
     * @Route("/", name="home")
     */
    public function index(Request $request): Response
    {
        $categories = $this->getDoctrine()
            ->getRepository(Category::class)
            ->findAll();

        $products = $this->getDoctrine()
            ->getRepository(Product::class)
            ->findAll();

        $form = $this->createForm(CategorySelectorType::class);
        $form->handleRequest($request);

        return $this->render('home/index.html.twig', [
            'categories' => $categories,
            'products' => $form->isSubmitted() && $form->isValid() ? ProductController::getChildrenProducts($form->get('category')->getData()) : $products,
            'form' => $form->createView()
        ]);
    }
}

www/project/templates/home/index.html.twig
{# Recursive category display #}
{% macro displayCategory(parent) %}
    {% import _self as self %}
    <li>
        <a href="{{ path('product_list_in_category', {category:parent.id}) }}">{{ parent.name }}</a>
        {% if parent.childrens %}
            <ul>
                {% for sub in parent.childrens %}
                    {{ self.displayCategory(sub) }}
                {% endfor %}
            </ul>
        {% endif %}
    </li>
{% endmacro %}

{% from _self import displayCategory %}
{% extends 'base.html.twig' %}

{% block title %}Review - Accueil{% endblock %}

{% block body %}
    <h1>Bienvenue sur Review !</h1>
    <h2>Liste des catégories</h2>
    <ul class="mb-2">
        {% for category in categories|filter(cat => cat.parent == null) %}
            {{ displayCategory(category) }}
        {% endfor %}
    </ul>
    <h2 class="mt-5">Liste des produits</h2>
    <h3>Choisir une catégorie</h3>
    {{ form_start(form) }}
        <div class="row">
            <div class="col">
                {{ form_row(form.category, {'label': false}) }}
            </div>
            <div class="col">
                <button type="submit" class="btn btn-primary">Rechercher</button>
            </div>
        </div>
    {{ form_end(form) }}
    <div class="row mt-5 mb-2">
        {% for product in products %}
            <div class="col-3">
                <div class="card" >
                    {% if product.thumbnail %}
                        <img class="card-img-top" src="{{ asset('uploads/pictures/' ~ product.thumbnail.url) }}" alt="{{ product.name }}">
                    {% endif %}
                    <div class="card-body">
                        <a href="{{ path('product_info', { product: product.id }) }}">{{ product.name }}</a>
                        <br>
                        {% if product.reviews is empty %}
                            <a href="{{ path('review_add', { product: product.id }) }}">Soyez le premier avis !</a>
                        {% else %}
                            {{ product.averageNote }} / 5
                        {% endif %}
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
    {% if is_granted('ROLE_ADMIN') %}
        <a href="{{ path('category_add') }}" class="btn btn-primary">Créer une catégorie</a>
        <a href="{{ path('product_add') }}" class="btn btn-primary">Créer un produit</a>
    {% endif %}
{% endblock %}